import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_coelacanth', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:alive_coelacanth", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_nautilus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:alive_nautilus", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_mosasaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:mosasaurus_sack", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_plesiosaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:plesiosaurus_sack", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});