import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_dodo', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:dodo_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_smilodon', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:smilodon_embryo", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_mammoth', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:mammoth_embryo", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});