import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_brachiosaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:brachiosaurus_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_stegosaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:stegosaurus_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_triceratops', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:triceratops_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});