import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_brachiosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_brachiosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_brachiosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_brachiosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_brachiosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_brachiosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:brachiosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:brachiosaurus_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_stegosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_stegosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_stegosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_stegosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_stegosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_stegosaurus_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:stegosaurus_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:stegosaurus_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_triceratops_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_triceratops_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_triceratops_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_triceratops_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_triceratops_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_triceratops_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:triceratops_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:triceratops_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});