import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_dilophosaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:dilophosaurus_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_spinosaurus', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:spinosaurus_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_velociraptor', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:velociraptor_egg", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});