import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_montsechia', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:montsechia_item", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_scale_tree', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:scale_sapling_item", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_tall_cycad', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:bucket", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:syringe", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:tall_cycad_sapling_item", 1), block.center());
                block.setType("jurassic:cultivator_block");
            }
        }
    });
});