import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:fossil_orevar', {
        onRandomTick(event) {
            const randomInt = Math.floor(Math.random() * 10) + 1;
            const { block } = event;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 1 || randomInt === 2 || randomInt === 3 || randomInt === 4 || randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 9) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 10) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
        onPlace(event) {
            const randomInt = Math.floor(Math.random() * 6) + 1;
            const { block } = event;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 2) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 1) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cenozoicfossilvar', {
        onRandomTick(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 10) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 1 || randomInt === 2 || randomInt === 3 || randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 9) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
            }

            if (randomInt === 10) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
        onPlace(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 7) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 2) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
            }

            if (randomInt === 1) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cretaceousfossilvar', {
        onRandomTick(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 10) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 1 || randomInt === 2) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 9) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 10) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
        onPlace(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 9) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 9) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 2) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 1) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:jurassicfossil', {
        onRandomTick(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 10) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 1 || randomInt === 2 || randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 9) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 10) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
        onPlace(event) {
            const { block } = event;
            const randomInt = Math.floor(Math.random() * 10) + 1;
            if (block.permutation.getState('jurassic:stay')) {
                return;
            }

            if (randomInt === 8) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 7) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 6) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 5) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 4) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 3) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 2) {
                block.setPermutation(block.permutation.withState('jurassic:var0', true));
                block.setPermutation(block.permutation.withState('jurassic:var3', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }

            if (randomInt === 1) {
                block.setPermutation(block.permutation.withState('jurassic:var0', false));
                block.setPermutation(block.permutation.withState('jurassic:var1', true));
                block.setPermutation(block.permutation.withState('jurassic:var2', true));
                block.setPermutation(block.permutation.withState('jurassic:stay', true));
            }
        },
    });
});