import { EquipmentSlot, ItemStack, world } from "@minecraft/server"

world.beforeEvents.worldInitialize.subscribe(ev => {
    ev.itemComponentRegistry.registerCustomComponent('jurassic:creaturepedia_item', {
        onUse({ source }) {
            const equippable = source?.getComponent("minecraft:equippable");
            if (!equippable) return;

            const mainhand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            mainhand.setItem(new ItemStack("jurassic:creaturepedia"));
        }
    });
});